1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
47 if [ $MSGLEVEL -le 3 ]; then
51 if [ $MSGLEVEL -le 4 ]; then
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
63 echo "${CDONE}DONE${CNORMAL}" >&2;
68 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f .
/aptconfig.conf
]; then
70 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
71 elif [ -f ..
/aptconfig.conf
]; then
72 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
74 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
77 aptconfig
() { runapt apt
-config $
*; }
78 aptcache
() { runapt apt
-cache $
*; }
79 aptget
() { runapt apt
-get $
*; }
80 aptftparchive
() { runapt apt
-ftparchive $
*; }
81 aptkey
() { runapt apt
-key $
*; }
82 aptmark
() { runapt apt
-mark $
*; }
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
87 if [ -f .
/aptconfig.conf
]; then
88 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
89 elif [ -f ..
/aptconfig.conf
]; then
90 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
92 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
97 CURRENTTRAP
="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
102 TMPWORKINGDIRECTORY
=$(mktemp -d)
103 local TESTDIR
=$(readlink -f $(dirname $0))
104 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
105 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
107 local OLDWORKINGDIRECTORY
=$(pwd)
108 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
109 cd $TMPWORKINGDIRECTORY
110 mkdir rootdir aptarchive keys
112 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
113 mkdir -p var
/cache var
/lib var
/log
114 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
115 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
119 touch var/lib/dpkg/status
121 touch var/lib/dpkg/available
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
129 local SOURCESSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
135 echo "Dir
\"${TMPWORKINGDIRECTORY}/rootdir
\";" > aptconfig.conf
136 echo "Dir
::state
::status
\"${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
/status
\";" >> aptconfig.conf
137 echo "Debug
::NoLocking
\"true
\";" >> aptconfig.conf
138 echo "APT
::Get
::Show
-User-Simulation-Note \"false
\";" >> aptconfig.conf
139 echo "Dir
::Bin
::Methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
140 echo "Dir
::Bin
::dpkg
\"fakeroot
\";" >> aptconfig.conf
141 echo "DPKG
::options
:: \"dpkg
\";" >> aptconfig.conf
142 echo "DPKG
::options
:: \"--root=${TMPWORKINGDIRECTORY}/rootdir
\";" >> aptconfig.conf
143 echo "DPKG
::options
:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG
::options
:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG
::options
:: \"--log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
\";" >> aptconfig.conf
146 echo 'quiet::NoUpdate "true
";' >> aptconfig.conf
148 export PATH="${PATH}:/usr
/local
/sbin
:/usr
/sbin
:/sbin
"
152 configarchitecture() {
153 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
155 echo "APT
::Architecture
\"$1\";" > $CONFFILE
157 while [ -n "$1" ]; do
158 echo "APT
::Architectures
:: \"$1\";" >> $CONFFILE
163 setupsimplenativepackage() {
167 local RELEASE="${4:-unstable}"
168 local DEPENDENCIES="$5"
169 local DESCRIPTION="$6"
170 local SECTION="${7:-others}"
172 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
175 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
177 local BUILDDIR=incoming/${NAME}-${VERSION}
178 mkdir -p ${BUILDDIR}/debian/source
180 echo "* most suckless software product ever
" > FEATURES
181 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
182 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
186 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
187 test -e debian/control || echo "Source
: $NAME
190 Maintainer
: Joe Sixpack
<joe@example.org
>
191 Build
-Depends: debhelper
(>= 7)
192 Standards
-Version: 3.9.1
194 Package
: $NAME" > debian/control
195 if [ "$ARCH" = 'all' ]; then
196 echo "Architecture
: all
" >> debian/control
198 echo "Architecture
: any
" >> debian/control
200 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
201 if [ -z "$DESCRIPTION" ]; then
202 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
203 If you
find such a package installed on your system
,
204 YOU did something horribly wrong
! They are autogenerated
205 und used only by testcases
for APT and surf no other propose…
" >> debian/control
207 echo "Description
: $DESCRIPTION" >> debian/control
209 test -e debian/compat || echo "7" > debian/compat
210 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
211 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
215 buildsimplenativepackage() {
219 local RELEASE="${4:-unstable}"
220 local DEPENDENCIES="$5"
221 local DESCRIPTION="$6"
222 local SECTION="${7:-others}"
223 local PRIORITY="${8:-optional}"
225 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
228 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
230 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
232 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
233 mkdir -p $BUILDDIR/debian/source
234 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
236 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
238 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
239 echo "$NAME ($VERSION) $RELEASE; urgency
=low
243 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
247 Maintainer
: Joe Sixpack
<joe@example.org
>
248 Standards
-Version: 3.9.1
250 Package
: $NAME" > ${BUILDDIR}/debian/control
251 if [ "$ARCH" = 'all' ]; then
252 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
254 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
256 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
257 if [ -z "$DESCRIPTION" ]; then
258 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
259 If you
find such a package installed on your system
,
260 YOU did something horribly wrong
! They are autogenerated
261 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
263 echo "Description
: $DESCRIPTION" >> ${BUILDIR}/debian/control
265 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
266 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
268 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
271 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
272 rm -rf ${BUILDDIR}/debian/tmp
273 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
274 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
275 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
276 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
277 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
279 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
280 echo "pool
/${NAME}_
${VERSION}_
${arch}.deb
" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
283 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
284 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
285 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
294 msgninfo "Build package
$(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}…
"
296 if [ "$ARCH" = "all
" ]; then
297 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
299 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
300 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
301 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
304 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
307 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
313 if [ -d incoming ]; then
314 buildaptarchivefromincoming $*
316 buildaptarchivefromfiles $*
320 createaptftparchiveconfig() {
321 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
322 if [ -z "$ARCHS" ]; then
323 # the pool is empty, so we will operate on faked packages - let us use the configured archs
324 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
327 ArchiveDir "' >> ftparchive.conf
328 echo -n $(readlink -f .) >> ftparchive.conf
330 CacheDir "' >> ftparchive.conf
331 echo -n $(readlink -f ..) >> ftparchive.conf
333 FileListDir "' >> ftparchive.conf
334 echo -n $(readlink -f pool/) >> ftparchive.conf
338 Packages::Compress ". gzip bzip2 lzma xz";
339 Sources::Compress ". gzip bzip2 lzma xz";
340 Contents::Compress ". gzip bzip2 lzma xz";
341 Translation::Compress ". gzip bzip2 lzma xz";
342 LongDescription "false";
346 SrcDirectory "pool/";
352 Label "apttestcases";
354 Description "repository with dummy packages";
355 Architectures "' >> ftparchive.conf
356 echo -n "$ARCHS" >> ftparchive.conf
360 };' >> ftparchive.conf
361 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
362 echo -n 'tree "dists/' >> ftparchive.conf
363 echo -n "$DIST" >> ftparchive.conf
365 Architectures "' >> ftparchive.conf
366 echo -n "$ARCHS" >> ftparchive.conf
368 FileList "' >> ftparchive.conf
369 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
371 SourceFileList "' >> ftparchive.conf
372 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
374 Sections "' >> ftparchive.conf
375 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
377 };' >> ftparchive.conf
381 buildaptftparchivedirectorystructure
() {
382 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
383 for DIST
in $DISTS; do
384 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
385 for SECTION
in $SECTIONS; do
386 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
387 for ARCH
in $ARCHS; do
388 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
390 mkdir -p dists
/${DIST}/${SECTION}/source
391 mkdir -p dists
/${DIST}/${SECTION}/i18n
401 local DEPENDENCIES
="$5"
402 local PRIORITY
="${6:-optional}"
404 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
405 if [ "$arch" = "all" ]; then
406 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
410 for BUILDARCH
in $ARCHS; do
411 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
412 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
413 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
414 local FILE
="${PPATH}/Packages"
419 Maintainer: Joe Sixpack <joe@example.org>
422 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
423 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
424 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
425 If you find such a package installed on your system,
426 YOU did something horribly wrong! They are autogenerated
427 und used only by testcases for APT and surf no other propose…
438 local DEPENDENCIES
="$5"
440 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
442 local FILE
="${SPATH}/Sources"
446 Maintainer: Joe Sixpack <joe@example.org>
447 Architecture: $ARCH" >> $FILE
448 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
450 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
451 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
454 insertinstalledpackage
() {
458 local DEPENDENCIES
="$4"
459 local PRIORITY
="${5:-optional}"
460 local FILE
="rootdir/var/lib/dpkg/status"
461 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
463 Status: install ok installed
467 Maintainer: Joe Sixpack <joe@example.org>
469 Version: $VERSION" >> $FILE
470 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
471 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
472 If you find such a package installed on your system,
473 YOU did something horribly wrong! They are autogenerated
474 und used only by testcases for APT and surf no other propose…
480 buildaptarchivefromincoming
() {
481 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
483 [ -e pool
] || ln -s ..
/incoming pool
484 [ -e ftparchive.conf
] || createaptftparchiveconfig
485 [ -e dists
] || buildaptftparchivedirectorystructure
486 msgninfo
"\tGenerate Packages, Sources and Contents files… "
487 aptftparchive
-qq generate ftparchive.conf
493 buildaptarchivefromfiles
() {
494 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
495 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
496 msgninfo
"\t${line} file… "
497 cat ${line} | gzip > ${line}.gz
498 cat ${line} | bzip2 > ${line}.bz2
499 cat ${line} | lzma
> ${line}.lzma
500 cat ${line} | xz
> ${line}.xz
506 # can be overridden by testcases for their pleasure
507 getcodenamefromsuite
() { echo -n "$1"; }
508 getreleaseversionfromsuite
() { true
; }
510 generatereleasefiles
() {
511 msgninfo
"\tGenerate Release files… "
512 local DATE
="${1:-now}"
513 if [ -e aptarchive
/dists
]; then
514 for dir
in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
515 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Patterns
::='Translation-*' > $dir/Index
517 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
518 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
519 local CODENAME
="$(getcodenamefromsuite $SUITE)"
520 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
521 if [ -z "$VERSION" ]; then
522 aptftparchive
-qq release
$dir \
523 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
524 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
525 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
527 aptftparchive
-qq release
$dir \
528 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
529 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
530 -o APT
::FTPArchive
::Release
::Version
="${VERSION}" \
531 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
533 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
535 NotAutomatic: yes' $dir/Release
539 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
541 if [ "$DATE" != "now" ]; then
542 for release
in $(find ./aptarchive -name 'Release'); do
543 touch -d "$1" $release
549 setupdistsaptarchive
() {
550 local APTARCHIVE
=$(readlink -f ./aptarchive)
551 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
552 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
553 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
554 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
555 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
556 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
557 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
562 setupflataptarchive
() {
563 local APTARCHIVE
=$(readlink -f ./aptarchive)
564 if [ -f ${APTARCHIVE}/Packages
]; then
565 msgninfo
"\tadd deb sources.list line… "
566 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
569 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
571 if [ -f ${APTARCHIVE}/Sources
]; then
572 msgninfo
"\tadd deb-src sources.list line… "
573 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
576 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
582 if [ -e aptarchive
/dists
]; then
588 msgninfo
"\tSync APT's cache with the archive… "
594 local SIGNER
="${1:-Joe Sixpack}"
595 msgninfo
"\tSign archive with $SIGNER key… "
597 for KEY
in $(find keys/ -name '*.sec'); do
598 SECKEYS
="$SECKEYS --secret-keyring $KEY"
601 for KEY
in $(find keys/ -name '*.pub'); do
602 PUBKEYS
="$PUBKEYS --keyring $KEY"
604 for RELEASE
in $(find aptarchive/ -name Release); do
605 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
606 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
611 changetowebserver
() {
612 if which weborf
> /dev
/null
; then
613 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
615 elif which lighttpd
> /dev
/null
; then
616 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
618 server.stat-cache-engine = \"disable\"" > lighttpd.conf
619 lighttpd
-t -f lighttpd.conf
>/dev
/null
|| msgdie
'Can not change to webserver: our lighttpd config is invalid'
620 lighttpd
-D -f lighttpd.conf
2>/dev
/null
>/dev
/null
&
623 msgdie
'You have to install weborf or lighttpd first'
626 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
627 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
628 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
634 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
635 if [ -n "$DIFFTEXT" ]; then
647 msgtest
"Test for correctness of file" "$FILE"
649 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
651 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
656 local COMPAREFILE
=$(mktemp)
657 addtrap
"rm $COMPAREFILE;"
658 echo "$1" > $COMPAREFILE
660 msgtest
"Test for equality of" "$*"
661 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
665 local COMPAREFILE1
=$(mktemp)
666 local COMPAREFILE2
=$(mktemp)
667 local COMPAREAGAINST
=$(mktemp)
668 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
669 echo "$1" > $COMPAREFILE1
670 echo "$2" > $COMPAREFILE2
672 msgtest
"Test for equality OR of" "$*"
673 $
* 2>&1 1> $COMPAREAGAINST
674 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
675 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
676 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
677 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
682 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
685 while [ -n "$1" ]; do
687 N: Can't select versions from package '$1' as it is purely virtual"
688 PACKAGE
="${PACKAGE} $1"
691 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
693 N: No packages found"
694 local COMPAREFILE
=$(mktemp)
695 addtrap
"rm $COMPAREFILE;"
696 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
697 eval `apt-config shell ARCH APT::Architecture`
698 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
699 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
703 msgtest
"Test for non-existent packages" "apt-cache show $*"
704 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
705 if [ -n "$SHOWPKG" ]; then
714 testdpkginstalled
() {
715 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
716 local PKGS
="$(dpkg -l $* | grep '^i' | wc -l)"
717 if [ "$PKGS" != $# ]; then
719 dpkg
-l $
* | grep '^[a-z]'
726 testdpkgnotinstalled
() {
727 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
728 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
729 if [ "$PKGS" != 0 ]; then
731 dpkg
-l $
* | grep '^[a-z]'
739 local COMPAREFILE
=$(mktemp)
740 addtrap
"rm $COMPAREFILE;"
742 msgtest
'Test for correctly marked as auto-installed' "$*"
743 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
745 msgtest
'Test for correctly marked as auto-installed' 'no package'
746 echo -n > $COMPAREFILE
748 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
752 echo "STOPPED execution. Press enter to continue"